## node-raptor 0~0git20130108

=== Makefile ===
RAPTOR_VERSION=2.0.6
RM=rm -rf
WAF=node-waf
DEPS_DIR=$(CURDIR)/deps
RAPTOR_NAME=raptor2-$(RAPTOR_VERSION)
RAPTOR_DIR=$(DEPS_DIR)/$(RAPTOR_NAME)
RAPTOR_TARBALL_NAME=$(RAPTOR_NAME).tar.gz
RAPTOR_TARBALL=$(DEPS_DIR)/$(RAPTOR_TARBALL_NAME)
RAPTOR_URL=http://download.librdf.org/source/$(RAPTOR_TARBALL_NAME)
RAPTOR_PREFIX?=$(RAPTOR_DIR)/dist
RAPTOR_STATIC_LIB:=$(RAPTOR_PREFIX)/lib/libraptor2.a
CFLAGS?=-g -Wall
CXXFLAGS?=-g -Wall
CFLAGS+=-fPIC
CXXFLAGS+=-fPIC
export RAPTOR_PREFIX CFLAGS CXXFLAGS	# export for waf

WGET=@-$(shell command -v curl > /dev/null 2>&1)
ifeq ($(WGET),)
	WGET=wget
else
	WGET=curl -O
endif

all: bindings

bindings: raptor
	cd src \
		&& $(WAF) configure \
		&& $(WAF) build

$(RAPTOR_TARBALL):
	-mkdir $(DEPS_DIR)
	cd $(DEPS_DIR) \
		&& $(WGET) $(RAPTOR_URL)

$(RAPTOR_DIR): $(RAPTOR_TARBALL)
	cd $(DEPS_DIR) \
		&& tar -xzf $(RAPTOR_TARBALL)

$(RAPTOR_STATIC_LIB): $(RAPTOR_DIR)
	cd $(RAPTOR_DIR) \
		&& ./configure \
		--prefix=$(RAPTOR_DIR)/dist \
		--enable-static \
		--disable-shared \
		--disable-gtk-doc-html
	make install -C $(RAPTOR_DIR)

ifeq ($(wildcard $(RAPTOR_STATIC_LIB)),)
raptor: $(RAPTOR_STATIC_LIB)
else
raptor:
endif

.PHONY: clean
clean: clean-bindings clean-raptor

clean-bindings:
	-cd src \
		&& $(WAF) distclean > /dev/null 2>&1
	-$(RM) build > /dev/null 2>&1

clean-raptor:
	-$(RM) $(RAPTOR_TARBALL) > /dev/null 2>&1
	-$(RM) $(RAPTOR_DIR) > /dev/null 2>&1
	-$(RM) $(DEPS_DIR) > /dev/null 2>&1

=== src/wscript ===
import os
import Options

srcdir='.'
blddir='../build'

# Check whether envinronment variable has been set by Makefile
if 'RAPTOR_PREFIX' in os.environ:
    RAPTOR_PREFIX = os.environ['RAPTOR_PREFIX']
else:
    RAPTOR_PREFIX = '/usr/local'

def set_options(ctx):
    ctx.add_option('--clang',
            action='store_true',
            default='',
            dest='use_clang',
            help='Uses the clang compiler')
    ctx.add_option('--analyze',
            action='store_true',
            default='',
            dest='analyze',
            help='Runs the clang static analyzer (implies --clang)')
    ctx.tool_options('compiler_cxx')

def configure(ctx):
    print "libraptor2 prefix: " + RAPTOR_PREFIX
    if Options.options.analyze:
        ctx.env.ANALYZE = Options.options.analyze
        Options.options.use_clang = 1

    if Options.options.use_clang:
        os.environ['CXX'] = '/usr/bin/clang'

    ctx.check_tool('compiler_cxx')
    ctx.check_tool('node_addon')

def build(ctx):
    obj = ctx.new_task_gen('cxx', 'shlib', 'node_addon')

    # Analyze
    if ctx.env.ANALYZE:
        obj.cxxflags = ['-g', '-Wall', '--analyze']
    else:
        obj.cxxflags = ['-g', '-Wall']

    obj.find_sources_in_dirs('.')

    obj.target   = 'bindings'
    obj.includes = RAPTOR_PREFIX + '/include/raptor2'
    obj.lib      = 'raptor2'
    obj.libpath  = RAPTOR_PREFIX + '/lib'

=== debian/changelog ===
node-raptor (0~0git20130108-1) unstable; urgency=low

  * Initial release.
    Closes: Bug#697941.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 12 Jan 2013 02:18:44 +0100

=== debian/control ===
Source: node-raptor
Section: libs
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs,
 devscripts,
 debhelper,
 dh-buildinfo,
 nodejs-dev,
 libraptor2-dev
Standards-Version: 3.9.4
Homepage: https://github.com/0xfeedface/node_raptor
Vcs-Git: git://git.debian.org/git/collab-maint/node-raptor
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/node-raptor.git

Package: node-raptor
Architecture: any
Depends: ${cdbs:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Description: Node.js bindings for libraptor2
 Node.js is an event-based server-side JavaScript engine.
 .
 Raptor is a C library providing a set of parsers and serializers for
 Resource Description Framework (RDF) triples by parsing syntaxes or
 serializing the triples into a syntax.
 .
 Node-raptor provides Raptor RDF parser and serializer bindings to
 Node.js.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2013 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for node_raptor
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/langcore.mk
include /usr/share/cdbs/1/rules/debhelper.mk

pkg = node-raptor

CDBS_BUILD_DEPENDS += , nodejs-dev, libraptor2-dev
CDBS_DEPENDS_$(pkg) = nodejs

DEB_UPSTREAM_URL = https://github.com/0xfeedface/node_raptor/archive
#DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)
DEB_UPSTREAM_TARBALL_BASENAME = 91abde
DEB_UPSTREAM_TARBALL_MD5 = 7215c1b992cca1a4cb7c381224297273

DEB_SRCDIR = src

DEB_INSTALL_DOCS_$(pkg) += README.mdown

# node-waf build routines
NODE-PATH = $(cdbs_curdestdir)usr/lib/nodejs/raptor/native
NODE-WAF-BUILDFLAGS = CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" CPPFLAGS="$(CPPFLAGS)" LINKFLAGS="$(LDFLAGS)"
NODE-WAF = NOCOLOR=1 NODE_PATH="$(NODE-PATH)" RAPTOR_PREFIX=/usr node-waf -v
configure/$(pkg):: debian/stamp-node-waf-configure
debian/stamp-node-waf-configure:
	cd $(DEB_SRCDIR) && $(NODE-WAF-BUILDFLAGS) $(NODE-WAF) configure
	touch $@
build/$(pkg):: debian/stamp-node-waf-build
debian/stamp-node-waf-build:
	cd $(DEB_SRCDIR) && $(NODE-WAF) build
	$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,make test)
	touch $@
install/$(pkg)::
	cd $(DEB_SRCDIR) && $(NODE-WAF) install
clean::
	rm -rf build
	rm -f $(DEB_SRCDIR)/.lock-wscript
	rm -f debian/stamp-node-waf-configure debian/stamp-node-waf-build

# Node modules have an uncommon extension preventing autodetection by
# dh_shlibdeps, so we do it manually
binary-strip-IMPL/$(pkg)::
	$(if $(is_debug_package)$(filter nostrip,$(DEB_BUILD_OPTIONS)),,find "$(cdbs_curdestdir)" -name "*.node" -exec strip --remove-section=.comment --remove-section=.note --strip-unneeded {} +)
binary-predeb-IMPL/$(pkg)::
	find "$(cdbs_curdestdir)" -name "*.node" -exec dpkg-shlibdeps -Tdebian/$(cdbs_curpkg).substvars {} +

=== debian/watch ===
version=3
https://github.com/0xfeedface/node_raptor/tags .*/archive/v?(\d[\d\.]+).tar.gz
